diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
index 301594ee2..463be32ef 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenCreateWorld.java
@@ -57,10 +57,10 @@ public class ScreenCreateWorld extends Screen {
             i18n.translateKey("gui.create_world.button.create_new_world")));
         buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 128 + 12,
             i18n.translateKey("gui.create_world.button.cancel")));
-        textboxWorldName = new TextFieldElement(this, font, width / 2 - 100, 60, 200 - 24, 20,
+        textboxWorldName = new TextFieldElement(this, fontRenderer, width / 2 - 100, 60, 200 - 24, 20,
             "", i18n.translateKey("gui.create_world.label.new_world"));
         textboxWorldName.setMaxStringLength(32);
-        textboxSeed = new TextFieldElement(this, font, width / 2 - 100, 100, 200 - 24, 20, "", Long.toString(seed));
+        textboxSeed = new TextFieldElement(this, fontRenderer, width / 2 - 100, 100, 200 - 24, 20, "", Long.toString(seed));
         buttons.add(gamemodeButton = new ButtonElement(2, width / 2 - 100, 100 + 20 + 4, 98, 20, ""));
         buttons.add(cheatsButton = new ButtonElement(3, width / 2 - 100 + 102, 100 + 20 + 4, 98, 20, ""));
         buttons.add(worldTypeButton = new ButtonElement(4, width / 2 - 100, 100 + 20 + 20 + 4 + 4, ""));
@@ -212,9 +212,9 @@ public class ScreenCreateWorld extends Screen {
     public void render(int mx, int my, float partialTick) {
         I18n stringtranslate = I18n.getInstance();
         renderBackground();
-        drawStringCentered(font, stringtranslate.translateKey("gui.create_world.label.title"), width / 2, 20, 0xffffff);
-        drawString(font, stringtranslate.translateKey("gui.create_world.label.world_name"), width / 2 - 100, 47, 0xa0a0a0);
-        drawString(font, stringtranslate.translateKey("gui.create_world.label.seed"), width / 2 - 100, 88, 0xa0a0a0);
+        drawStringCenteredShadow(fontRenderer, stringtranslate.translateKey("gui.create_world.label.title"), width / 2, 20, 0xffffff);
+        drawStringShadow(fontRenderer, stringtranslate.translateKey("gui.create_world.label.world_name"), width / 2 - 100, 47, 0xa0a0a0);
+        drawStringShadow(fontRenderer, stringtranslate.translateKey("gui.create_world.label.seed"), width / 2 - 100, 88, 0xa0a0a0);
         textboxWorldName.drawTextBox();
         textboxWorldName.updateCursor(mc, mx, my);
         textboxSeed.drawTextBox();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java
index 953bd40f0..650fe998f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenCredits.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -120,7 +121,7 @@ public class ScreenCredits extends Screen {
 
         super.render(mx, my, partialTick);
 
-        font.drawCenteredString(I18n.getInstance().translateKey("gui.credits.label.title"), width / 2, 5, 0xFFFFFF);
+        drawStringCenteredNoShadow(fontRenderer, I18n.getInstance().translateKey("gui.credits.label.title"), width / 2, 5, 0xFFFFFF);
 
         Scissor.enable(0, top, width, bottom - top);
         drawContent();
@@ -138,15 +139,15 @@ public class ScreenCredits extends Screen {
             String line = lines.get(i);
             if (line.startsWith("*")) {
                 line = TextFormatting.BOLD + line.substring(1);
-                int lineWidth = font.getStringWidth(line) + line.length();
-                font.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, 0xFFFFFF);
+                int lineWidth = MathHelper.ceil(fontRenderer.stringWidthDouble(line)) + line.length();
+                drawStringNoShadow(this.fontRenderer, line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, 0xFFFFFF);
             } else if (line.startsWith("!")) {
                 int rgb = Color.HSBtoRGB(hue / 360f, 1.0f, 1.0f);
                 line = TextFormatting.BOLD + line.substring(1);
-                int lineWidth = font.getStringWidth(line) + line.length();
-                font.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, rgb);
+                int lineWidth = MathHelper.ceil(fontRenderer.stringWidthDouble(line)) + line.length();
+                drawStringNoShadow(this.fontRenderer, line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, rgb);
             } else {
-                font.drawString(line, width / 2 - font.getStringWidth(line) / 2, 100 + i * 12 - (int) scrollAmount, 0x7F7F7F);
+                drawStringNoShadow(this.fontRenderer, line, MathHelper.ceil((width - fontRenderer.stringWidthDouble(line)) / 2), 100 + i * 12 - (int) scrollAmount, 0x7F7F7F);
             }
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
index c6ff2bb3f..d776d2bb8 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenDownloadTerrain.java
@@ -49,7 +49,7 @@ public class ScreenDownloadTerrain extends Screen
     {
         renderTexturedBackground();
         I18n i18n = I18n.getInstance();
-        drawStringCentered(font, i18n.translateKey("gui.downloading_terrain.label.title"), width / 2, height / 2 - 50, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKey("gui.downloading_terrain.label.title"), width / 2, height / 2 - 50, 0xffffff);
         super.render(mx, my, partialTick);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
new file mode 100644
index 000000000..9809e3626
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenFontTest.java
@@ -0,0 +1,94 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.client.render.font.Alignment;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.net.ChatEmotes;
+import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+
+import java.util.Map;
+
+public class ScreenFontTest extends Screen{
+    public double scroll = 0;
+    public ScreenFontTest(final @Nullable Screen parent) {
+        super(parent);
+    }
+    @Override
+    public void render(final int mx, final int my, final float partialTick) {
+        renderTexturedBackground();
+        super.render(mx, my, partialTick);
+
+        scroll += Mouse.getDWheel() * fontRenderer.fontHeight()/2;
+
+//        drawStringCenteredNoShadow(this.mc.font, "§l§oBetter than Adventure!", this.width /2, this.height /2 - 30, 0x22ffffff);
+//        this.fontRenderer.renderCentered(Tessellator.instance,  "§l§oBetter than Adventure!", this.width /2, this.height /2 - 20, 0, false, 0xffffffL, null, null, null);
+
+//        FontHelper.renderWidthConstrained(Tessellator.instance,
+//            "§bLorem ipsum dolor sit amet, §+§3consectetur adipiscing elit, sed do eiusmod tempor incididunt §+§1ut labore et §+§rdolore magna aliqua.§- Ut enim §-ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut §-aliquip ex ea commodo consequat. Duis aute irure dolor in §+§rreprehenderit in voluptate velit esse cillum dolore §-eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. \n Test String1!",
+//            (this.width/2) - 120, this.height/2, 240).setColor(0xFFAAFF).call(this.fontRenderer);
+//
+//        FontHelper.render(Tessellator.instance, "Test String2!", (this.width/2) - 120, FontHelper.getLastEndingY()).call(this.fontRenderer);
+//        FontHelper.render(Tessellator.instance, "Test String3!", (this.width/2) - 120, FontHelper.getLastEndingY()).setColor(0xFF0000).call(this.fontRenderer);
+//        FontHelper.render(Tessellator.instance, "Test String4!", (this.width/2) - 120, FontHelper.getLastEndingY()).call(this.fontRenderer);
+
+//        StringBuilder builder = new StringBuilder();
+//        for (char i = 0; i < 256; i++) {
+//            builder.append(i);
+//            if (i != 0 && i % 16 == 0) {
+//                builder.append("\n");
+//            }
+//        }
+//
+//        FontHelper.renderWidthConstrained(Tessellator.instance, builder, (this.width/2) - 120, FontHelper.getLastEndingY(), Integer.MAX_VALUE).call(this.fontRenderer);
+
+        drawRect((width - 400)/2, 10, (width + 400)/2, 400, 0xFF232323);
+        long start = System.currentTimeMillis();
+        final StringBuilder builder = new StringBuilder("§0§0§0§0§<AAAAFF>");
+        for (int i = 0; i < 1000; i++) {
+            builder.append("a");
+        }
+        builder.append("\n").append(ChatAllowedCharacters.ALLOWED_CHARACTERS);
+        builder.append("\n").append("Obfuscation test: §kTEST STRING §r§<FFAAAA> Static Text");
+        builder.append("\n").append("\tTab");
+        builder.append("\n").append("\t\tTabTab");
+        builder.append("\n").append("   TripleSpace");
+
+        for (Map.Entry<String, Character> entry : ChatEmotes.getEmotes().entrySet()) {
+            builder.append("\n").append(entry.getKey().replace(":", "")).append(": ").append(entry.getValue());
+        }
+
+        builder.append("\n§bLorem ipsum dolor sit amet, §+§3consectetur adipiscing elit, sed do eiusmod tempor incididunt §+§1ut labore et §+§rdolore magna aliqua.§- Ut enim §-ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut §-aliquip ex ea commodo consequat. Duis aute irure dolor in §+§rreprehenderit in voluptate velit esse cillum dolore §-eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. \nTest String1!");
+        FontHelper.renderWidthConstrained(Tessellator.instance, builder, (width - 400)/2, (int) (10 + scroll), 400).setAlignment(Alignment.LEFT).setColor(0xFFAAFF).setShadow().call(this.fontRenderer);
+        final long bigStringRenderTime = System.currentTimeMillis() - start;
+        FontHelper.render(Tessellator.instance, "" + bigStringRenderTime/1000f, (width - 400)/2, FontHelper.getLastEndingY() + 20).call(this.fontRenderer);
+
+        final long memTotal = Runtime.getRuntime().totalMemory();
+        final long memFree = Runtime.getRuntime().freeMemory();
+        final long memUsed = memTotal - memFree;
+
+        FontHelper.render(Tessellator.instance, "" + memUsed/(1024 * 1024) + "MB", (width - 400)/2, FontHelper.getLastEndingY() + 20).call(this.fontRenderer);
+
+        final double mouseX = (double) (Mouse.getX() * this.mc.resolution.getScaledWidthScreenCoords()) / this.mc.resolution.getWidthScreenCoords();
+        final double mouseY =  (this.mc.resolution.getScaledHeightScreenCoords() - (double) (Mouse.getY() * this.mc.resolution.getScaledHeightScreenCoords()) / this.mc.resolution.getHeightScreenCoords());
+
+        FontHelper.renderDouble(Tessellator.instance, "Double Precision", mouseX - this.fontRenderer.stringWidthDouble("Double Precision") - 3, mouseY - 6).setShadow().call(this.fontRenderer);
+        FontHelper.render(Tessellator.instance, "Int Precision", (int) (mouseX + 3), (int) (mouseY - 5)).setShadow().call(this.fontRenderer);
+
+//        StringBuilder message = new StringBuilder("<Useless7695> ");
+//        for (char i = '!'; i <= '~'; i++) {
+//            message.append(i);
+//        }
+//        for (char i = '!'; i <= '~'; i++) {
+//            message.append(i);
+//        }
+//        for (char i = '!'; i <= '~'; i++) {
+//            message.append(i);
+//        }
+//
+//        FontHelper.renderWidthConstrained(Tessellator.instance, message, (this.width - 320)/2, 10, 320).setShadow().call(this.fontRenderer);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
index 2207e2514..46fb3619e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenGameOver.java
@@ -68,9 +68,9 @@ public class ScreenGameOver extends Screen
         drawGradientRect(0, 0, width, height, 0x60500000, 0xa0803030);
         GL11.glPushMatrix();
         GL11.glScalef(2.0F, 2.0F, 2.0F);
-        drawStringCentered(font, i18n.translateKey("gui.game_over.label.title"), width / 2 / 2, 30, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKey("gui.game_over.label.title"), width / 2 / 2, 30, 0xffffff);
         GL11.glPopMatrix();
-        drawStringCentered(font, i18n.translateKeyAndFormat("gui.game_over.label.score", TextFormatting.YELLOW.toString() + mc.thePlayer.getScore()), width / 2, 100, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKeyAndFormat("gui.game_over.label.score", TextFormatting.YELLOW.toString() + mc.thePlayer.getScore()), width / 2, 100, 0xffffff);
         super.render(mx, my, partialTick);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
index 1a72d3bc1..bb3b458bb 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenLabelEditor.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.packet.PacketSetItemName;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -76,19 +77,19 @@ public class ScreenLabelEditor extends Screen implements ITextField
         final int heightBG = 89;
         drawTexturedModalRect(widthBG, heightBG, 0, 0, 113, 34);
 
-        drawStringCentered(font, screenTitle, width / 2, 40, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, screenTitle, width / 2, 40, 0xffffff);
 
-        drawStringCentered(font, TextFormatting.get(color) + "> " + text + " <", width / 2, 100, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, TextFormatting.get(color) + "> " + text + " <", width / 2, 100, 0xffffff);
 
         boolean drawCursor = !text.isEmpty() && (cursorCounter / 6) % 2 == 0;
         if (drawCursor)
         {
-            int width = font.getStringWidth(editor.getText());
+            int width = MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText()));
             if (editor.getCursor() < editor.getText().length())
             {
-                width = font.getStringWidth(editor.getText().substring(0, editor.getCursor()));
+                width = MathHelper.ceil(fontRenderer.stringWidthDouble(editor.getText().substring(0, editor.getCursor())));
             }
-            drawString(font, "_", this.width / 2 - font.getStringWidth(editor.getText())/2 + width, 101, 0xffffff);
+            drawStringShadow(fontRenderer, "_", MathHelper.ceil(this.width - fontRenderer.stringWidthDouble(editor.getText())/2) + width, 101, 0xffffff);
         }
         super.render(mx, my, f);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
index 1c250c023..35554f56f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMainMenu.java
@@ -357,20 +357,20 @@ public class ScreenMainMenu extends Screen
         GL11.glTranslatef(width / 2 + 140, 80F, 0.0F);
         GL11.glRotatef(-20F, 0.0F, 0.0F, 1.0F);
         float f1 = 1.8F - MathHelper.abs(MathHelper.sin(((float)(System.currentTimeMillis() % 1000L) / 1000F) * MathHelper.PI * 2.0F) * 0.1F);
-        f1 = (f1 * 100F) / (float)(font.getStringWidth(splashText) + 32);
+        f1 = (f1 * 100F) / (float)(fontRenderer.stringWidthDouble(splashText) + 32);
         GL11.glScalef(f1, f1, f1);
-        drawStringCentered(font, splashText, 0, -8, 0xffff00);
+        drawStringCenteredShadow(fontRenderer, splashText, 0, -8, 0xffff00);
         GL11.glPopMatrix();
         int versionTextColor = mc.gameSettings.alphaMenu.value || !mc.mainMenuBackground.isEnabled() ? 0x505050 : 0xFFFFFF;
         if (showBuildTime) {
-            drawString(font, buildTimeString, 2, 2, versionTextColor);
+            drawStringShadow(fontRenderer, buildTimeString, 2, 2, versionTextColor);
         } else {
-            drawString(font, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
+            drawStringShadow(fontRenderer, "Better than Adventure! " + Minecraft.VERSION, 2, 2, versionTextColor);
         }
         String disclaimer1 = i18n.translateKey("gui.main_menu.label.disclaimer.1");
-        drawString(font, disclaimer1, width - font.getStringWidth(disclaimer1) - 2, height - 20, 0xffffff);
+        drawStringShadow(fontRenderer, disclaimer1, width - MathHelper.ceil(fontRenderer.stringWidthDouble(disclaimer1)) - 2, height - 20, 0xffffff);
         String disclaimer2 = i18n.translateKey("gui.main_menu.label.disclaimer.2");
-        drawString(font, disclaimer2, width - font.getStringWidth(disclaimer2) - 2, height - 10, 0xffffff);
+        drawStringShadow(fontRenderer, disclaimer2, width - MathHelper.ceil(fontRenderer.stringWidthDouble(disclaimer2)) - 2, height - 10, 0xffffff);
         super.render(mx, my, partialTick);
         
     	if(mc.downloadResourcesThread.downloading) {
@@ -378,7 +378,7 @@ public class ScreenMainMenu extends Screen
     		b = b * 0.2 + 0.8;
     		int ib = (int) java.lang.Math.round(b * 255);
     		int color = 0xFF000000 + (ib << 16) + (ib << 8) + (ib);
-    		mc.font.drawCenteredString(
+            drawStringCenteredShadow(mc.font,
                 i18n.translateKeyAndFormat("gui.main_menu.label.downloading_resources", mc.downloadResourcesThread.downloadProgress.get(), mc.downloadResourcesThread.toDownload),
                 width / 2, 16, color);
     	}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java
index de969de3e..0922fba33 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenMissingMinecraft.java
@@ -22,19 +22,19 @@ public class ScreenMissingMinecraft extends Screen {
         buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, i.translateKey("gui.no_minecraft.button.quit")));
         ClickableLabelElement installLabel = new ClickableLabelElement(1, width / 2 - 170, (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA);
         buttons.add(installLabel);
-        buttons.add(new ClickableLabelElement(2, 0,  height - font.fontHeight - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
+        buttons.add(new ClickableLabelElement(2, 0,  height - mc.font.fontHeight() - 4, i.translateKey("gui.main_menu.button.discord"), 0x5865F2));
     }
     @Override
     public void render(int mx, int my, float partialTick)
     {
         I18n i = I18n.getInstance();
         drawBackground(partialTick);
-        drawStringCentered(font, i.translateKey("gui.no_minecraft.label.title"), width / 2, (height / 4 - 60) + 20, 0xffff60);
-        drawString(font, i.translateKey("gui.no_minecraft.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xdedede);
-        drawString(font, i.translateKey("gui.no_minecraft.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xdedede);
-        drawString(font, i.translateKey("gui.no_minecraft.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xdedede);
-        drawString(font, i.translateKey("gui.no_minecraft.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xdedede);
-        drawString(font, i.translateKey("gui.no_minecraft.label.body.5"), width / 2 - 170, (height / 4 - 60) + 60 + 54, 0xdedede);
+        drawStringCenteredShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.title"), width / 2, (height / 4 - 60) + 20, 0xffff60);
+        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xdedede);
+        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xdedede);
+        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xdedede);
+        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xdedede);
+        drawStringShadow(fontRenderer, i.translateKey("gui.no_minecraft.label.body.5"), width / 2 - 170, (height / 4 - 60) + 60 + 54, 0xdedede);
         super.render(mx, my, partialTick);
     }
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenOutOfMemory.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenOutOfMemory.java
index 1c3e59e98..4e49474a1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenOutOfMemory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenOutOfMemory.java
@@ -13,13 +13,13 @@ public class ScreenOutOfMemory extends Screen
     {
         I18n i18n = I18n.getInstance();
         renderBackground();
-        drawStringCentered(font, i18n.translateKey("gui.out_of_memory.label.title"), width / 2, (height / 4 - 60) + 20, 0xFFFFFF);
-        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xA0A0A0);
-        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xA0A0A0);
-        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xA0A0A0);
-        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xA0A0A0);
-        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.5"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xA0A0A0);
-        drawString(font, i18n.translateKey("gui.out_of_memory.label.body.6"), width / 2 - 140, (height / 4 - 60) + 60 + 63, 0xA0A0A0);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKey("gui.out_of_memory.label.title"), width / 2, (height / 4 - 60) + 20, 0xFFFFFF);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xA0A0A0);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xA0A0A0);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xA0A0A0);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xA0A0A0);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.5"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xA0A0A0);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.out_of_memory.label.body.6"), width / 2 - 140, (height / 4 - 60) + 60 + 63, 0xA0A0A0);
         super.render(mx, my, partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java
index 6744edbca..7fc9bbcc5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPaintingPicker.java
@@ -125,8 +125,8 @@ public class ScreenPaintingPicker
 
         glEnable(GL_TEXTURE_2D);
 
-        drawString(font, centerArt.title, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 4, 0xFFFFFFFF);
-        drawString(font, centerArt.artist, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 16, 0x7F7F7F7F);
+        drawStringShadow(fontRenderer, centerArt.title, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 4, 0xFFFFFFFF);
+        drawStringShadow(fontRenderer, centerArt.artist, centerX - offsetX, centerY + (centerArt.sizeY / 2) * scale + 16, 0x7F7F7F7F);
 
         glEnable(GL_BLEND);
         glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
index 418ed37f2..733ace42f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPause.java
@@ -119,11 +119,11 @@ public class ScreenPause extends Screen
             float f1 = ((float)(updateCounter % 10) + partialTick) / 10F;
             f1 = MathHelper.sin(f1 * MathHelper.PI * 2.0F) * 0.2F + 0.8F;
             int k = (int)(255F * f1);
-            drawString(font, i.translateKey("gui.ingame_menu.label.saving"), 8, height - 16, k << 16 | k << 8 | k);
+            drawStringShadow(fontRenderer, i.translateKey("gui.ingame_menu.label.saving"), 8, height - 16, k << 16 | k << 8 | k);
         }
-        drawStringCentered(font, i.translateKey("gui.ingame_menu.label.title"), width / 2, 40, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, i.translateKey("gui.ingame_menu.label.title"), width / 2, 40, 0xffffff);
         String score = TextFormatting.YELLOW.toString() + mc.thePlayer.getScore();
-        drawStringCentered(font, i.translateKeyAndFormat("gui.ingame_menu.label.score", score), width / 2, 56, 0xfefefe);
+        drawStringCenteredShadow(fontRenderer, i.translateKeyAndFormat("gui.ingame_menu.label.score", score), width / 2, 56, 0xfefefe);
         super.render(mx, my, partialTick);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
index f0707cedd..e26e6b12b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenPhotoMode.java
@@ -5,7 +5,6 @@ import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.util.helper.FileOpener;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.helper.Utils;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.Seasons;
 import org.lwjgl.input.Keyboard;
@@ -450,7 +449,7 @@ public class ScreenPhotoMode extends Screen
             }
         }
         
-        if (showHelpText) drawStringCentered(font, I18n.getInstance().translateKey("gui.photo_mode.label.mouse_hint"), width / 2, height - 36, 0xFFFFFF);
+        if (showHelpText) drawStringCenteredShadow(fontRenderer, I18n.getInstance().translateKey("gui.photo_mode.label.mouse_hint"), width / 2, height - 36, 0xFFFFFF);
     }
 
     private void updateButtonsText()
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectServer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectServer.java
index 6095d0a70..6e404da79 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectServer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSelectServer.java
@@ -213,7 +213,7 @@ public class ScreenSelectServer extends Screen {
 	@Override
 	public void render(int mx, int my, float partialTick) {
 		worldSlotContainer.render(mx, my, partialTick);
-		drawStringCentered(font, screenTitle, width / 2, 20, 0xffffff);
+		drawStringCenteredShadow(fontRenderer, screenTitle, width / 2, 20, 0xffffff);
 		super.render(mx, my, partialTick);
 	}
 	
@@ -266,31 +266,31 @@ public class ScreenSelectServer extends Screen {
 			String line1 = server.nickname;
 			String line2 = server.address;
 
-			drawString(font, line1, x + 2, y + 1, 0xffffff);
-			if (server.showIp) drawString(font, line2, x + 2, y + 12 + 10, 0x404040);
+			drawStringShadow(fontRenderer, line1, x + 2, y + 1, 0xffffff);
+			if (server.showIp) drawStringShadow(fontRenderer, line2, x + 2, y + 12 + 10, 0x404040);
 			if (server.isUp && server.protocolVersion != Global.MP_PROTOCOL_VERSION) {
 				String outdated = I18n.getInstance().translateKey("gui.select_server.label.outdated");
-				int width = font.getStringWidth(outdated);
-				drawString(font, outdated, x + 220 - width - 4, y + 1, 0xFF0000);
-				width = font.getStringWidth(server.version);
-				drawString(font, server.version, x + 220 - width - 4, y + 12, 0xFF0000);
-				drawString(font, server.motd, x + 2, y + 12, 0x808080);
+				int width = MathHelper.ceil(fontRenderer.stringWidthDouble(outdated));
+				drawStringShadow(fontRenderer, outdated, x + 220 - width - 4, y + 1, 0xFF0000);
+				width = MathHelper.ceil(fontRenderer.stringWidthDouble(server.version));
+				drawStringShadow(fontRenderer, server.version, x + 220 - width - 4, y + 12, 0xFF0000);
+				drawStringShadow(fontRenderer, server.motd, x + 2, y + 12, 0x808080);
 			} else if (server.isUp) {
 				String latency = server.latency + "ms";
-				int width = font.getStringWidth(latency);
+				int width = MathHelper.ceil(fontRenderer.stringWidthDouble(latency));
 				float green = 1.0f - MathHelper.clamp((float)server.latency / 500.0F, 0.0F, 1.0F);
 				float red = 1.0F - green;
 				int argb = 0xFF000000 | (int)(255.0F * red) << 16 | (int)(255.0F * green) << 8;
 
-				drawString(font, latency, x + 220 - width - 4, y + 1, argb);
+				drawStringShadow(fontRenderer, latency, x + 220 - width - 4, y + 1, argb);
 				String players = server.currentPlayers + "/" + server.maxPlayers;
-				width = font.getStringWidth(players);
-				drawString(font, players, x + 220 - width - 4, y + 12, 0x808080);
-				drawString(font, server.motd, x + 2, y + 12, 0x808080);
+				width = MathHelper.ceil(fontRenderer.stringWidthDouble(players));
+				drawStringShadow(fontRenderer, players, x + 220 - width - 4, y + 12, 0x808080);
+				drawStringShadow(fontRenderer, server.motd, x + 2, y + 12, 0x808080);
 			} else {
 				String down = I18n.getInstance().translateKey("gui.select_server.label.down");
-				int width = font.getStringWidth(down);
-				drawString(font, down, x + 220 - width - 4, y + 1, 0xFF0000);
+				int width = MathHelper.ceil(fontRenderer.stringWidthDouble(down));
+				drawStringShadow(fontRenderer, down, x + 220 - width - 4, y + 1, 0xFF0000);
 			}
 		}
 	}
